var scfsOverlay = {
  onLoad: function() {
    var scfsFieldArray = window.arguments[0].inn;
    if (Array.isArray(scfsFieldArray)) {
      var scfsFieldArrayLength = scfsFieldArray.length;
      if (scfsFieldArrayLength > 0) {
        var localMenuParent = document.getElementById("scfsCriteriaMenuPopup");
        var localNewMenuItem = null;
        var localCounter = 0;
        var localTempName = "";
        for (localCounter = 0; localCounter < scfsFieldArrayLength; localCounter++) {
          localTempName = scfsFieldArray[localCounter][0];
          localNewMenuItem = document.createElement("menuitem");
            localNewMenuItem.setAttribute("id","scfsCriteriaMenuItem"+localTempName);
            localNewMenuItem.setAttribute("label",scfsFieldArray[localCounter][1]);
            localNewMenuItem.setAttribute("value",scfsFieldArray[localCounter][0]);
          localMenuParent.appendChild(localNewMenuItem);
        }
      }
    }
  },

  scfsChildNodeCleanup: function(localParentNode) {
    while (localParentNode.firstChild) {
      if (localParentNode.firstChild.hasChildNodes()) {
        this.scfsChildNodeCleanup(localParentNode.firstChild);
      }
      localParentNode.removeChild(localParentNode.firstChild);
    }
  },

  doOK: function() {
    var localSortTreeNodes = document.getElementById("scfsCriteriaTreeChildren").childNodes;
    var localSortTreeNodesLength = localSortTreeNodes.length;
    if (localSortTreeNodesLength > 0) {
      var localTempNode = null;
      var localTempNode1 = null;
      var localTempNode2 = null;
      var localCounter = 0;
      var localCounter1 = 0;
      var localArray = new Array();
      var localSortText = new String();
      var localTempText = " ";
      for (localCounter = 0; localCounter < localSortTreeNodesLength; localCounter++) {
        localTempNode = localSortTreeNodes[localCounter].firstChild;
        localTempNode1 = localTempNode.firstChild;
        localTempNode2 = localTempNode.lastChild;
        if (String(localTempText).indexOf(" "+localTempNode1.getAttribute("scfsvalue")+" ") < 0) {
          localSortText = localSortText+localTempNode1.getAttribute("scfsvalue")+" "+localTempNode2.getAttribute("scfsvalue")+",";
          localArray[localCounter1] = localTempNode1.getAttribute("label")+"\t"+localTempNode2.getAttribute("label");
          localTempText = localTempText + " "+localTempNode1.getAttribute("scfsvalue")+" ";
          localCounter1 = localCounter1 + 1;
        }
      }
      localArray[localCounter1] = localSortText+"id ASC";
      window.arguments[0].out = localArray;
    }
    return true;
  },

  scfsCriteriaAdd: function() {
    var localMenuList = document.getElementById("scfsCriteriaMenulist");
    if (localMenuList.selectedItem.value != "null") {
      var localNodeParent = document.getElementById("scfsCriteriaTreeChildren");
      var localItemCount = parseInt(localNodeParent.getAttribute("scsfcount"));
      if (isFinite(localItemCount) == false) { localItemCount = 0; }
      localItemCount++;
      var localItemCountTxt = "scsfcount"+String(localItemCount);
      var localTreeItem = document.createElement("treeitem");
        localTreeItem.setAttribute("id",localItemCountTxt+"treeItem");
      var localTreeRow = document.createElement("treerow");
        localTreeRow.setAttribute("id",localItemCountTxt+"treeRow");
      var localTreeCell1 = document.createElement("treecell");
        localTreeCell1.setAttribute("id",localItemCountTxt+"FieldName");
        localTreeCell1.setAttribute("label",localMenuList.selectedItem.label);
        localTreeCell1.setAttribute("scfsvalue",localMenuList.selectedItem.value);
        localTreeCell1.setAttribute("editable","false");
      var localTreeCell2 = document.createElement("treecell");
        localTreeCell2.setAttribute("id",localItemCountTxt+"FieldType");
        localTreeCell2.setAttribute("label",
          document.getElementById("scfsCriteriaRadioGroup").selectedItem.label);
        localTreeCell2.setAttribute("scfsvalue",
          document.getElementById("scfsCriteriaRadioGroup").selectedItem.value);
        localTreeCell2.setAttribute("editable","false");
      localTreeRow.appendChild(localTreeCell1);
      localTreeRow.appendChild(localTreeCell2);
      localTreeItem.appendChild(localTreeRow);
      localNodeParent.appendChild(localTreeItem);
      localNodeParent.setAttribute("scsfcount",String(localItemCount));
    }
  },

  scfsCriteriaDelete: function() {
    var localNodeParentTree = document.getElementById("scfsCriteriaTree");
    var localSelectedChildIdx = localNodeParentTree.currentIndex;
    var localNodeParentTreeChildren = document.getElementById("scfsCriteriaTreeChildren");
    var localTreeChildrenNodes = localNodeParentTreeChildren.childNodes;
    var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                           .getService(Components.interfaces.nsIPromptService);
    var localPromptTitle = document.getElementById("scfsStrings")
                                .getString("scfsDeleteFieldAlertTitle");
    if ((localSelectedChildIdx >= 0) && (localSelectedChildIdx < localTreeChildrenNodes.length)) {
      var localPromptMessage = document.getElementById("scfsStrings")
                                 .getString("scfsDeleteFieldAlertConfirm");
      if (localPrompts.confirm(null,localPromptTitle, localPromptMessage)) {
        var tempNode = localTreeChildrenNodes[localSelectedChildIdx];
        this.scfsChildNodeCleanup(tempNode);
        localNodeParentTreeChildren.removeChild(tempNode);
      }
    } else {
      var localPromptMessage = document.getElementById("scfsStrings")
                                 .getString("scfsDeleteFieldAlertMessage");
      localPrompts.alert(null,localPromptTitle, localPromptMessage);
    }
  }
}
